#include "download-async.h"

#include <glib.h>

static void
progress (gchar    *uri,
          gchar    *path,
          guint64   downloaded_bytes,
          guint64   total_bytes,
          gpointer  user_data)
{
    // This could be outputted into a GUI application or file, callback makes
    // it easy to work with progress
    g_print ("[ %06.2f%% ] %lu / %lu\n", (gfloat) ((gfloat) downloaded_bytes / (gfloat) total_bytes) * 100, downloaded_bytes, total_bytes);
}

/*
static void
example_callback (gchar *uri,
                  gchar *path,
                  gpointer user_data)
{

}
*/

static void
download (gchar *uri,
          gchar *path)
{
    GCancellable *cancellable = g_cancellable_new ();

    download_resource_from_uri_async_full (uri,
                                           path,
                                           TRUE,
                                           cancellable,
                                           progress,
                                           NULL,
                                           NULL,
                                           NULL);
}
int
main (int    argc,
      char **argv)
{
    GMainLoop *loop = NULL;
    gchar *uri;

    //uri = g_strdup (argv[1]);
    uri = "http://deow9bq0xqvbj.cloudfront.net/image-logo/597680/agaegrragr.png";
    //uri = "https://download.fedoraproject.org/pub/fedora/linux/releases/26/Workstation/x86_64/iso/Fedora-Workstation-Live-x86_64-26-1.5.iso";
    //uri = "http://releases.ubuntu.com/16.04.3/ubuntu-16.04.3-desktop-amd64.iso";

    if (!uri)
    {
        g_print ("%s needs a uri passed as the first argument, kill with CTRL-C.\n", argv[0]);
        return 0;
    }

    download (uri, NULL);
    //download (uri, "/home/julian/Downloads/test.png");
    //download (uri, "/home/julian/Downloads/temp/");

    loop = g_main_loop_new (NULL, FALSE);
	g_main_loop_run (loop);
    g_main_loop_unref (loop);

    return 0;
}

